Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents dgAddressBook As System.Windows.Forms.DataGrid
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents mnuFile As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExitSep As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Friend WithEvents dlgOpenFile As System.Windows.Forms.OpenFileDialog
    Friend WithEvents mnuFileSave As System.Windows.Forms.MenuItem

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.dgAddressBook = New System.Windows.Forms.DataGrid()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu()
        Me.mnuFile = New System.Windows.Forms.MenuItem()
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem()
        Me.mnuFileExitSep = New System.Windows.Forms.MenuItem()
        Me.mnuFileExit = New System.Windows.Forms.MenuItem()
        Me.dlgOpenFile = New System.Windows.Forms.OpenFileDialog()
        Me.mnuFileSave = New System.Windows.Forms.MenuItem()
        CType(Me.dgAddressBook, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'dgAddressBook
        '
        Me.dgAddressBook.DataMember = ""
        Me.dgAddressBook.Dock = System.Windows.Forms.DockStyle.Fill
        Me.dgAddressBook.Name = "dgAddressBook"
        Me.dgAddressBook.Size = New System.Drawing.Size(432, 149)
        Me.dgAddressBook.TabIndex = 0
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile})
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileOpen, Me.mnuFileSave, Me.mnuFileExitSep, Me.mnuFileExit})
        Me.mnuFile.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 0
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open..."
        '
        'mnuFileExitSep
        '
        Me.mnuFileExitSep.Index = 2
        Me.mnuFileExitSep.Text = "-"
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 3
        Me.mnuFileExit.Text = "E&xit"
        '
        'dlgOpenFile
        '
        Me.dlgOpenFile.Filter = "XML Files (*.xml)|*.xml|All Files (*.*)|*.*"
        '
        'mnuFileSave
        '
        Me.mnuFileSave.Index = 1
        Me.mnuFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS
        Me.mnuFileSave.Text = "&Save"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(432, 149)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.dgAddressBook})
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "EditXml []"
        CType(Me.dgAddressBook, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The name of the XML file.
    Private m_FileName As String

    ' The DataSet that will hold the data.
    Private m_DataSet As New DataSet()

    ' Set the initial dialog directory.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim path_name As String = Application.StartupPath

        dlgOpenFile.InitialDirectory = path_name.Substring(0, path_name.LastIndexOf("\"))
    End Sub

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub

    ' Load an XML file.
    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        ' Make sure the data is safe.
        If Not DataSafe() Then Exit Sub

        ' Let the user select the file.
        If dlgOpenFile.ShowDialog() = DialogResult.OK Then
            Try
                ' Start a new DataSet.
                m_DataSet = New DataSet()

                ' Read the XML data.
                dgAddressBook.DataSource = Nothing
                m_DataSet.ReadXml(dlgOpenFile.FileName)
                m_DataSet.AcceptChanges()

                ' Bind the DataGrid to the DataSet.
                dgAddressBook.DataSource = m_DataSet

                ' Display the file name in the form's caption.
                m_FileName = dlgOpenFile.FileName
                Me.Text = "EditXml [" & m_FileName & "]"

                ' Display the DataSet's structure.
                DisplayDataSetStructure(m_DataSet)
            Catch exc As Exception
                MsgBox(exc.Message)
                Me.Text = "EditXml []"
            End Try
        End If
    End Sub

    ' Return True if the data is safe.
    Private Function DataSafe() As Boolean
        ' If there are no pending changes,
        ' the data is safe.
        If Not m_DataSet.HasChanges() Then Return True

        ' Ask the user if we should save the changes.
        Select Case MsgBox("Save changes?", MsgBoxStyle.YesNoCancel, "Save Changes?")
            Case MsgBoxResult.No
                ' The data is safe.
                Return True
            Case MsgBoxResult.Yes
                ' Save the changes.
                SaveData()

                ' Return False if we failed to save
                ' the data for some reason.
                Return (Not m_DataSet.HasChanges())
            Case MsgBoxResult.Cancel
                ' The user wants to cancel this operation.
                ' Do not let the program discard the data.
                Return False
        End Select
    End Function

    ' Save the data.
    Private Sub mnuFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSave.Click
        SaveData()
    End Sub

    ' Save the data.
    Private Sub SaveData()
        m_DataSet.WriteXml(m_FileName)
        m_DataSet.AcceptChanges()
    End Sub

    ' Display the DataSet's structure.
    Private Sub DisplayDataSetStructure(ByVal m_DataSet As DataSet)
        Dim data_table As DataTable
        Dim data_column As DataColumn
        Dim data_relation As DataRelation

        ' Tell how many tables.
        Debug.WriteLine(m_DataSet.Tables.Count & " tables")

        ' Display the tables.
        For Each data_table In m_DataSet.Tables
            ' Display the table's name.
            Debug.WriteLine("******************************")
            Debug.WriteLine("Table " & data_table.TableName)

            ' Display the table's columns.
            For Each data_column In data_table.Columns
                Debug.WriteLine("Column " & data_column.ColumnName & _
                    " (" & data_column.DataType.ToString & ")")
            Next data_column

            ' Display the table's child relations.
            For Each data_relation In data_table.ChildRelations
                DisplayDataRelation("Child relation: ", data_relation)
            Next data_relation

            ' Display the table's parent relations.
            For Each data_relation In data_table.ParentRelations
                DisplayDataRelation("Parent relation: ", data_relation)
            Next data_relation
        Next data_table
    End Sub

    ' Display information about this DataRelation.
    Private Sub DisplayDataRelation(ByVal relation_name As String, ByVal data_relation As DataRelation)
        Dim parent_columns() As DataColumn
        Dim child_columns() As DataColumn
        Dim i As Integer

        parent_columns = data_relation.ParentColumns
        child_columns = data_relation.ChildColumns
        For i = 0 To parent_columns.GetUpperBound(0)
            Debug.WriteLine(relation_name & _
                parent_columns(i).Table.TableName & "." & _
                parent_columns(i).ColumnName & " = " & _
                child_columns(i).Table.TableName & "." & _
                child_columns(i).ColumnName)
        Next i
    End Sub

    ' Prevent the closing if the data is not safe.
    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        e.Cancel = (Not DataSafe())
    End Sub
End Class
