Imports System.Data.SqlClient

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents mnuFile As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileServer As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents grdResults As System.Windows.Forms.DataGrid
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu()
        Me.mnuFile = New System.Windows.Forms.MenuItem()
        Me.mnuFileServer = New System.Windows.Forms.MenuItem()
        Me.MenuItem3 = New System.Windows.Forms.MenuItem()
        Me.mnuFileExit = New System.Windows.Forms.MenuItem()
        Me.grdResults = New System.Windows.Forms.DataGrid()
        CType(Me.grdResults, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile})
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileServer, Me.MenuItem3, Me.mnuFileExit})
        Me.mnuFile.Text = "&File"
        '
        'mnuFileServer
        '
        Me.mnuFileServer.Index = 0
        Me.mnuFileServer.Shortcut = System.Windows.Forms.Shortcut.CtrlS
        Me.mnuFileServer.Text = "&Server..."
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 1
        Me.MenuItem3.Text = "-"
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 2
        Me.mnuFileExit.Text = "E&xit"
        '
        'grdResults
        '
        Me.grdResults.DataMember = ""
        Me.grdResults.Dock = System.Windows.Forms.DockStyle.Fill
        Me.grdResults.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.grdResults.Name = "grdResults"
        Me.grdResults.ReadOnly = True
        Me.grdResults.Size = New System.Drawing.Size(544, 249)
        Me.grdResults.TabIndex = 0
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(544, 249)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.grdResults})
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "ExploreRelations"
        CType(Me.grdResults, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_DataSet As DataSet

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Close()
    End Sub

    ' Let the user select the server.
    Private Sub mnuFileServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileServer.Click
        ' Let the user select the database.
        Dim dlg As New dlgSqlServerLogin()
        If dlg.ShowDialog() = DialogResult.Cancel Then Exit Sub

        grdResults.DataSource = Nothing
        Me.Cursor = Cursors.WaitCursor
        Me.Refresh()

        ' Explore the database's relations.
        ExploreRelations(dlg.txtServer.Text, dlg.txtUserId.Text, dlg.txtPassword.Text, dlg.txtDatabase.Text)

        Me.Cursor = Cursors.Default
    End Sub

    ' Display information about the database's relations.
    Private Sub ExploreRelations(ByVal server_name As String, ByVal user_name As String, ByVal user_password As String, ByVal database_name As String)
        Me.Text = "ExploreRelations - connecting..."
        Me.Refresh()

        ' Connect to the server.
        Dim connect_string As String = _
            "User Id=" & user_name & ";" & _
            "Password=" & user_password & ";" & _
            "Data Source=" & server_name
        Dim sql_connection As New SqlConnection(connect_string)
        sql_connection.Open()

        ' Use the database.
        Dim cmd As New SqlCommand("USE " & database_name, sql_connection)
        cmd.ExecuteNonQuery()

        ' Make a list of the tables.
        cmd.CommandText = "sp_tables"
        Dim data_reader As SqlDataReader = cmd.ExecuteReader()
        Dim table_names As New Collection()
        Do While data_reader.Read()
            ' Save only normal TABLEs.
            If data_reader.Item("TABLE_TYPE") = "TABLE" Then
                table_names.Add(data_reader.Item("TABLE_NAME"))
            End If
        Loop
        data_reader.Close()

        ' Remove the previous data.
        m_DataSet = New DataSet()

        ' Explore the tables.
        Dim table_name As String
        For Each table_name In table_names
            Me.Text = "ExploreRelations - " & table_name
            Me.Refresh()
            ExploreTable(sql_connection, table_name)
        Next table_name

        sql_connection.Close()
        grdResults.DataSource = m_DataSet
        Me.Text = "ExploreRelations [" & server_name & "." & database_name & "]"
    End Sub

    ' Explore a table.
    Private Sub ExploreTable(ByVal sql_connection As SqlConnection, ByVal table_name As String)
        ' Make a DataTable to hold the column data.
        Dim data_table As New DataTable(table_name)
        m_DataSet.Tables.Add(data_table)

        ' Make the DataTable columns.
        data_table.Columns.Add("Column", GetType(String))
        data_table.Columns.Add("Type", GetType(String))
        data_table.Columns.Add("Precision", GetType(String))
        data_table.Columns.Add("IsNullable", GetType(String))
        data_table.Columns.Add("KeySeq", GetType(String))
        data_table.Columns.Add("ReferencedBy", GetType(String))

        ' Make a list of the table's columns.
        Dim cmd As New SqlCommand("sp_columns " & table_name, sql_connection)
        Dim data_reader As SqlDataReader = cmd.ExecuteReader()
        Dim data_row As DataRow
        Do While data_reader.Read()
            ' Add a DataRow for the column.
            data_row = data_table.NewRow()
            data_row.Item("Column") = data_reader.Item("COLUMN_NAME")
            data_row.Item("Type") = data_reader.Item("TYPE_NAME")
            data_row.Item("Precision") = data_reader.Item("PRECISION")
            data_row.Item("IsNullable") = data_reader.Item("IS_NULLABLE")
            data_table.Rows.Add(data_row)
        Loop
        data_reader.Close()

        ' Get information about the table's primary keys.
        cmd.CommandText = "sp_pkeys " & table_name
        data_reader = cmd.ExecuteReader()
        Do While data_reader.Read()
            ' Find the column's DataRow.
            Dim data_rows() As DataRow = _
                data_table.Select("Column = '" & _
                    data_reader.Item("COLUMN_NAME") & "'")

            ' Set the column's KeySeq value.
            data_rows(0).Item("KeySeq") = data_reader.Item("KEY_SEQ")
        Loop
        data_reader.Close()

        ' Get information about foreign keys
        ' referencing this table's columns.
        cmd.CommandText = "sp_fkeys " & table_name
        data_reader = cmd.ExecuteReader()
        Do While data_reader.Read()
            ' Find the column's DataRow.
            Dim data_rows() As DataRow = _
                data_table.Select("Column = '" & _
                    data_reader.Item("PKCOLUMN_NAME") & "'")

            ' Set the column's ReferencedBy value.
            Dim txt As String = "" & data_rows(0).Item("ReferencedBy")
            If txt.Length > 0 Then txt = txt & vbCrLf
            txt = txt & _
                data_reader.Item("FKTABLE_NAME") & "." & _
                data_reader.Item("FKCOLUMN_NAME")
            data_rows(0).Item("ReferencedBy") = txt
        Loop
        data_reader.Close()
    End Sub
End Class
