Imports System.Data.SqlClient

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents mnuFile As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileServer As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents trvResults As System.Windows.Forms.TreeView
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.trvResults = New System.Windows.Forms.TreeView()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu()
        Me.mnuFile = New System.Windows.Forms.MenuItem()
        Me.mnuFileServer = New System.Windows.Forms.MenuItem()
        Me.MenuItem3 = New System.Windows.Forms.MenuItem()
        Me.mnuFileExit = New System.Windows.Forms.MenuItem()
        Me.SuspendLayout()
        '
        'trvResults
        '
        Me.trvResults.Dock = System.Windows.Forms.DockStyle.Fill
        Me.trvResults.ImageIndex = -1
        Me.trvResults.Name = "trvResults"
        Me.trvResults.SelectedImageIndex = -1
        Me.trvResults.Size = New System.Drawing.Size(292, 273)
        Me.trvResults.TabIndex = 0
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile})
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileServer, Me.MenuItem3, Me.mnuFileExit})
        Me.mnuFile.Text = "&File"
        '
        'mnuFileServer
        '
        Me.mnuFileServer.Index = 0
        Me.mnuFileServer.Shortcut = System.Windows.Forms.Shortcut.CtrlS
        Me.mnuFileServer.Text = "&Server..."
        '
        'MenuItem3
        '
        Me.MenuItem3.Index = 1
        Me.MenuItem3.Text = "-"
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 2
        Me.mnuFileExit.Text = "E&xit"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.trvResults})
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "ExploreServer"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Close()
    End Sub

    ' Let the user select the server.
    Private Sub mnuFileServer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileServer.Click
        ' Let the user select the database.
        Dim dlg As New dlgSqlServerLogin()
        If dlg.ShowDialog() = DialogResult.Cancel Then Exit Sub

        trvResults.Nodes.Clear()
        Me.Cursor = Cursors.WaitCursor
        Me.Refresh()

        ' Explore the server.
        ExploreServer(dlg.txtServer.Text, dlg.txtUserId.Text, dlg.txtPassword.Text)

        Me.Cursor = Cursors.Default
    End Sub

    ' Display information about the server.
    Private Sub ExploreServer(ByVal server_name As String, ByVal user_name As String, ByVal user_password As String)
        ' Make a node for the server.
        Dim server_node As TreeNode = trvResults.Nodes.Add(server_name)

        Me.Text = "ExploreServer - connecting..."
        Me.Refresh()

        ' Connect to the server.
        Dim connect_string As String = _
            "User Id=" & user_name & ";" & _
            "Password=" & user_password & ";" & _
            "Data Source=" & server_name
        Dim sql_connection As New SqlConnection(connect_string)
        sql_connection.Open()

        ' Make a list of the databases.
        Dim cmd As New SqlCommand("sp_databases", sql_connection)
        Dim data_reader As SqlDataReader = cmd.ExecuteReader()
        Dim database_names As New Collection()
        Do While data_reader.Read()
            database_names.Add(data_reader.Item("DATABASE_NAME"))
        Loop
        data_reader.Close()

        ' Explore the databases.
        Dim database_name As String
        For Each database_name In database_names
            Me.Text = "ExploreServer - " & database_name
            Me.Refresh()
            ExploreDatabase(sql_connection, server_node, database_name)
        Next database_name

        sql_connection.Close()
        Me.Text = "ExploreServer [" & server_name & "]"
    End Sub

    ' Explore a database.
    Private Sub ExploreDatabase(ByVal sql_connection As SqlConnection, ByVal server_node As TreeNode, ByVal database_name As String)
        ' Add a node for the database.
        Dim database_node As TreeNode = server_node.Nodes.Add(database_name)

        ' Select the database.
        Dim cmd As New SqlCommand("USE " & database_name, sql_connection)
        cmd.ExecuteNonQuery()

        ' Make a list of the database's tables.
        cmd.CommandText = "sp_tables"
        Dim data_reader As SqlDataReader = cmd.ExecuteReader()
        Dim table_names As New Collection()
        Do While data_reader.Read()
            table_names.Add(data_reader.Item("TABLE_NAME"))
        Loop
        data_reader.Close()

        ' Explore the tables.
        Dim table_name As String
        For Each table_name In table_names
            ExploreTable(sql_connection, database_node, table_name)
        Next table_name
    End Sub

    ' Explore a table.
    Private Sub ExploreTable(ByVal sql_connection As SqlConnection, ByVal database_node As TreeNode, ByVal table_name As String)
        ' Add a node for the table.
        Dim table_node As TreeNode = database_node.Nodes.Add(table_name)

        ' Make a list of the table's columns.
        Dim cmd As New SqlCommand("sp_columns " & table_name, sql_connection)
        Dim data_reader As SqlDataReader = cmd.ExecuteReader()
        Dim txt As String
        Dim type_name As String
        Do While data_reader.Read()
            ' Make a TreeView node for the column.
            type_name = data_reader.Item("TYPE_NAME")
            txt = data_reader.Item("COLUMN_NAME") & "    " & type_name
            If (type_name = "char") Or (type_name = "varchar") Then
                txt = txt & "(" & data_reader.Item("PRECISION") & ")"
            End If
            If data_reader.Item("IS_NULLABLE").ToLower <> "yes" Then
                txt = txt & " NOT NULL"
            End If

            table_node.Nodes.Add(txt)
        Loop
        data_reader.Close()
    End Sub
End Class
