Imports System.Data.SqlClient

Module DataStuff

    Private Const APP_TITLE = "OrderEntryTabs"

    Public Const CONNECT_STRING = _
        "data source=Bender\NETSDK;initial catalog=MultiUserOrders;user id=sa"

    ' The user ID.
    Public g_UserId As String

    ' The main MDI form.
    Public g_MdiMain As mdiMain

    '' True when the data is modified.
    'Public m_DataModified As Boolean

    ' Objects that work with the database.
    Public g_DataSet As New DataSet()

    ' DataTables.
    Public g_dtCustomerList As DataTable
    'Public WithEvents g_dtCustomers As DataTable
    'Public WithEvents g_dtCustomerOrders As DataTable
    'Public WithEvents g_dtCustomerAddresses As DataTable
    'Public WithEvents g_dtOrderItems As DataTable
    'Public WithEvents g_dtOrderDates As DataTable

    ' SqlDataAdapters.
    'Public g_daCustomers As SqlDataAdapter
    'Public g_daCustomerOrders As SqlDataAdapter
    'Public g_daCustomerAddresses As SqlDataAdapter
    'Public g_daOrderItems As SqlDataAdapter
    'Public g_daOrderDates As SqlDataAdapter

    ' CurrencyManagers.
    Public WithEvents g_cmCustomers As CurrencyManager

    ' Execute a scalar SQL statement.
    Private Function ExecuteScalarStatement(ByVal statement) As Object
        ' Prepare the command.
        Dim conn As New SqlConnection(CONNECT_STRING)
        Dim cmd As New SqlCommand(statement, conn)

        ' Execute the command.
        conn.Open()
        Dim result As Object = cmd.ExecuteScalar()
        conn.Close()

        ' Return the result
        Return result
    End Function

    ' Return the largest customer ID.
    Public Function MaxCustomerId() As Integer
        Return ExecuteScalarStatement("SELECT MAX(CustomerId) FROM Customers")
    End Function

    ' Load the data displayed in the customer list.
    Public Sub LoadCustomerListData()
        ' Create a data adapter.
        Dim select_statement As String = _
            "SELECT CustomerName + ' (' + LTRIM(CustomerId) + ')' AS CombinedName, CustomerId FROM Customers ORDER BY CombinedName"
        Dim data_adapter = New SqlDataAdapter( _
            select_statement, CONNECT_STRING)

        ' Map the default table name "Table" to CustomerList.
        data_adapter.TableMappings.Add("Table", "CustomerList")

        ' Clear any existing data (in case we're reloading).
        If Not (g_dtCustomerList Is Nothing) Then g_dtCustomerList.Clear()

        ' Load the DataSet.
        data_adapter.Fill(g_DataSet)

        ' Save a reference to the new table.
        g_dtCustomerList = g_DataSet.Tables("CustomerList")
    End Sub

    ' Execute an SQL action statement.
    Public Function ExecuteNonQuery(ByVal statement As String) As Integer
        ' Prepare the command.
        Dim conn As New SqlConnection(CONNECT_STRING)
        Dim cmd As New SqlCommand(statement, conn)

        ' Execute the command.
        conn.Open()
        Dim result As Integer = cmd.ExecuteNonQuery()
        conn.Close()

        ' Return the result
        Return result
    End Function
End Module
