Public Class frmCustomerList
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnCustomerDelete As System.Windows.Forms.Button
    Friend WithEvents btnCustomerAdd As System.Windows.Forms.Button
    Friend WithEvents lstCustomers As System.Windows.Forms.ListBox
    Friend WithEvents btnRefresh As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnCustomerDelete = New System.Windows.Forms.Button()
        Me.btnCustomerAdd = New System.Windows.Forms.Button()
        Me.lstCustomers = New System.Windows.Forms.ListBox()
        Me.btnRefresh = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'btnCustomerDelete
        '
        Me.btnCustomerDelete.Location = New System.Drawing.Point(216, 88)
        Me.btnCustomerDelete.Name = "btnCustomerDelete"
        Me.btnCustomerDelete.Size = New System.Drawing.Size(64, 24)
        Me.btnCustomerDelete.TabIndex = 11
        Me.btnCustomerDelete.Text = "Delete"
        '
        'btnCustomerAdd
        '
        Me.btnCustomerAdd.Location = New System.Drawing.Point(216, 56)
        Me.btnCustomerAdd.Name = "btnCustomerAdd"
        Me.btnCustomerAdd.Size = New System.Drawing.Size(64, 24)
        Me.btnCustomerAdd.TabIndex = 10
        Me.btnCustomerAdd.Text = "Add"
        '
        'lstCustomers
        '
        Me.lstCustomers.IntegralHeight = False
        Me.lstCustomers.Name = "lstCustomers"
        Me.lstCustomers.Size = New System.Drawing.Size(192, 168)
        Me.lstCustomers.TabIndex = 9
        '
        'btnRefresh
        '
        Me.btnRefresh.Location = New System.Drawing.Point(216, 0)
        Me.btnRefresh.Name = "btnRefresh"
        Me.btnRefresh.Size = New System.Drawing.Size(64, 24)
        Me.btnRefresh.TabIndex = 12
        Me.btnRefresh.Text = "Refresh"
        '
        'frmCustomerList
        '
        Me.AcceptButton = Me.btnRefresh
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(288, 253)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnRefresh, Me.btnCustomerDelete, Me.btnCustomerAdd, Me.lstCustomers})
        Me.Name = "frmCustomerList"
        Me.Text = "Customer List"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Our CurrencyManager.
    Private m_cmCustomerList As CurrencyManager

    Private Sub frmCustomerList_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        ArrangeControls()
    End Sub
    Private Sub ArrangeControls()
        Const GAP = 8
        Dim wid As Integer
        Dim hgt As Integer
        Dim X As Integer
        Dim Y As Integer

        wid = btnRefresh.Size.Width
        hgt = btnRefresh.Size.Height
        X = ClientSize.Width - wid
        btnRefresh.SetBounds(X, btnRefresh.Location.Y, wid, hgt)
        btnCustomerAdd.SetBounds(X, btnCustomerAdd.Location.Y, wid, hgt)
        btnCustomerDelete.SetBounds(X, btnCustomerDelete.Location.Y, wid, hgt)

        wid = X - 2 * GAP
        lstCustomers.SetBounds(0, 0, wid, ClientSize.Height)
    End Sub

    ' Bind the ListBox to the Customers DataTable.
    Private Sub frmCustomerList_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lstCustomers.DataSource = g_dtCustomerList
        lstCustomers.DisplayMember = "CombinedName"

        ' Save a reference to the Customers CurrencyManager.
        m_cmCustomerList = Me.BindingContext(g_dtCustomerList)
    End Sub

    ' Display the selected customer.
    Private Sub lstCustomers_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstCustomers.DoubleClick
        DisplayCustomerForm()
    End Sub

    ' Display the selected customer.
    Private Sub DisplayCustomerForm()
        ' Get the customer's ID.
        Dim data_row_view As DataRowView = m_cmCustomerList.Current
        Dim customer_id As Integer = data_row_view.Item("CustomerId")

        ' See if this customer is already displayed.
        Dim frm As frmCustomer = FindCustomerForm(customer_id)
        If frm Is Nothing Then
            ' Create and display a new customer form.
            frm = New frmCustomer()
            frm.CustomerId = customer_id
            frm.MdiParent = Me.MdiParent
            frm.Show()
        Else
            ' Set focus to the existing form.
            If frm.WindowState = FormWindowState.Minimized Then frm.WindowState = FormWindowState.Normal
            frm.Focus()
        End If
    End Sub

    ' Find the customer's display form if it is loaded.
    Function FindCustomerForm(ByVal customer_id As Integer) As frmCustomer
        Dim frm As frmCustomer
        Dim child As Form

        For Each child In Me.MdiParent.MdiChildren
            ' Only check frmCustomer forms.
            If child.GetType Is GetType(frmCustomer) Then
                ' See if this form is already displaying 
                ' the customer.
                frm = child
                If frm.CustomerId = customer_id Then
                    ' This is the form.
                    Return frm
                End If
            End If
        Next child

        ' We did not find the form.
        Return Nothing
    End Function

    ' Add a new customer.
    Private Sub btnCustomerAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCustomerAdd.Click
        ' Ask the user for the new customer name.
        Dim dlg As New frmNewCustomer()
        If dlg.ShowDialog(Me) = DialogResult.OK Then
            ' Get the customer name.
            Dim customer_name As String = dlg.txtCompanyName.Text
            Dim customer_id As Integer
            Dim statement As String

            ' Try to create a new record.
            Dim attempt As Integer
            For attempt = 1 To 10
                ' Get the next available CustomerId.
                customer_id = MaxCustomerId() + 1

                ' Compose an INSERT statement.
                statement = "INSERT INTO Customers " & _
                    "(CustomerId, CustomerName, ReservedBy) VALUES (" & _
                    customer_id & ", '" & customer_name & "', NULL)"

                ' Try to execute the statement.
                If ExecuteNonQuery(statement) = 1 Then Exit For

                ' This attempt failed. Try again.
            Next attempt

            ' See if we failed. This is unlikely unless
            ' the database load is high.
            If attempt > 10 Then
                MsgBox("Unable to create Customers record." & _
                    vbCrLf & "Try again.", _
                    MsgBoxStyle.Information, "Create Failed")
                Exit Sub
            End If

            ' Add a new entry to the list.
            m_cmCustomerList.AddNew()
            Dim data_row_view As DataRowView = m_cmCustomerList.Current
            data_row_view.Item("CustomerId") = customer_id
            data_row_view.Item("CombinedName") = customer_name & " (" & customer_id & ")"
            m_cmCustomerList.EndCurrentEdit()

            ' Display the new customer.
            DisplayCustomerForm()
        End If
    End Sub

    ' Delete the current customer.
    Private Sub btnCustomerDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCustomerDelete.Click
        ' Do nothing if there are no records to delete.
        If m_cmCustomerList.Count < 1 Then Exit Sub

        ' Get the DataRowView.
        Dim data_row_view As DataRowView
        data_row_view = m_cmCustomerList.Current()

        ' See if this this customer is currently displayed.
        Dim frm As frmCustomer = FindCustomerForm(data_row_view.Item("CustomerId"))
        If Not (frm Is Nothing) Then
            ' Tell the user to close the form.
            MsgBox("This customer's detail form is open." & _
                vbCrLf & "Close the customer's form before deleting it.", _
                MsgBoxStyle.Information, "Customer Open")
            Exit Sub
        End If

        ' Make the user confirm.
        If MsgBox("Are you sure you want to delete this customer?", _
            MsgBoxStyle.Question Or MsgBoxStyle.YesNo) = MsgBoxResult.Yes _
        Then
            ' Delete the record from the database.
            Dim statement As String = _
                "DELETE FROM Customers WHERE CustomerId = " & _
                data_row_view.Item("CustomerId") & _
                " AND ReservedBy IS NULL"
            If ExecuteNonQuery(statement) <> 1 Then
                MsgBox("Error deleting customer from the database." & _
                    vbCrLf & "The customer may be missing or reserved for editing.", _
                    MsgBoxStyle.Information, "Delete Error")
            Else
                ' Delete the record from the list.
                data_row_view.Delete()
            End If
        End If
    End Sub

    ' Requery the database and rebuild the list.
    Private Sub btnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRefresh.Click
        LoadCustomerListData()
    End Sub
End Class
