Public Class frmCustomerList
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnCustomerDelete As System.Windows.Forms.Button
    Friend WithEvents btnCustomerAdd As System.Windows.Forms.Button
    Friend WithEvents lstCustomers As System.Windows.Forms.ListBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnCustomerDelete = New System.Windows.Forms.Button()
        Me.btnCustomerAdd = New System.Windows.Forms.Button()
        Me.lstCustomers = New System.Windows.Forms.ListBox()
        Me.SuspendLayout()
        '
        'btnCustomerDelete
        '
        Me.btnCustomerDelete.Location = New System.Drawing.Point(120, 200)
        Me.btnCustomerDelete.Name = "btnCustomerDelete"
        Me.btnCustomerDelete.Size = New System.Drawing.Size(64, 24)
        Me.btnCustomerDelete.TabIndex = 11
        Me.btnCustomerDelete.Text = "Delete"
        '
        'btnCustomerAdd
        '
        Me.btnCustomerAdd.Location = New System.Drawing.Point(24, 200)
        Me.btnCustomerAdd.Name = "btnCustomerAdd"
        Me.btnCustomerAdd.Size = New System.Drawing.Size(64, 24)
        Me.btnCustomerAdd.TabIndex = 10
        Me.btnCustomerAdd.Text = "Add"
        '
        'lstCustomers
        '
        Me.lstCustomers.IntegralHeight = False
        Me.lstCustomers.Location = New System.Drawing.Point(8, 8)
        Me.lstCustomers.Name = "lstCustomers"
        Me.lstCustomers.Size = New System.Drawing.Size(192, 168)
        Me.lstCustomers.TabIndex = 9
        '
        'frmCustomerList
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(208, 253)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnCustomerDelete, Me.btnCustomerAdd, Me.lstCustomers})
        Me.Name = "frmCustomerList"
        Me.Text = "Customer List"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub frmCustomerList_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        ArrangeControls()
    End Sub
    Private Sub ArrangeControls()
        Const GAP = 8
        Dim wid As Integer
        Dim hgt As Integer
        Dim X As Integer
        Dim Y As Integer

        wid = btnCustomerAdd.Size.Width
        hgt = btnCustomerAdd.Size.Height
        X = (ClientSize.Width - 3 * GAP) \ 2 - wid
        Y = ClientSize.Height - hgt - GAP
        btnCustomerAdd.SetBounds(X, Y, wid, hgt)
        X = X + wid + 3 * GAP
        btnCustomerDelete.SetBounds(X, Y, wid, hgt)
        lstCustomers.SetBounds(0, 0, ClientSize.Width, Y - GAP)
    End Sub

    ' Bind the ListBox to the Customers DataTable.
    Private Sub frmCustomerList_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lstCustomers.DataSource = g_dtCustomers
        lstCustomers.DisplayMember = "CombinedName"

        ' Save a reference to the Customers CurrencyManager.
        g_cmCustomers = Me.BindingContext(g_dtCustomers)
    End Sub

    ' Display the selected customer.
    Private Sub lstCustomers_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstCustomers.DoubleClick
        DisplayCustomerForm()
    End Sub

    ' Display the selected customer.
    Private Sub DisplayCustomerForm()
        ' Get the customer's ID.
        Dim data_row_view As DataRowView = g_cmCustomers.Current

        ' See if this customer is already displayed.
        Dim frm As frmCustomer = FindCustomerForm(data_row_view.Item("CustomerId"))
        If frm Is Nothing Then
            ' Create and display a new customer form.
            frm = New frmCustomer()
            frm.CustomerDataRow = data_row_view.Row
            frm.MdiParent = Me.MdiParent
            frm.Show()
        Else
            ' Set focus to the existing form.
            If frm.WindowState = FormWindowState.Minimized Then frm.WindowState = FormWindowState.Normal
            frm.Focus()
        End If
    End Sub

    ' Find the customer's display form if it is loaded.
    Function FindCustomerForm(ByVal customer_id As Integer) As frmCustomer
        Dim frm As frmCustomer
        Dim child As Form

        For Each child In Me.MdiParent.MdiChildren
            ' Only check frmCustomer forms.
            If child.GetType Is GetType(frmCustomer) Then
                ' See if this form is already displaying 
                ' the customer.
                frm = child
                If frm.CustomerId = customer_id Then
                    ' This is the form.
                    Return frm
                End If
            End If
        Next child

        ' We did not find the form.
        Return Nothing
    End Function

    ' Add a new customer.
    Private Sub btnCustomerAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCustomerAdd.Click
        ' End any current edits.
        EndAllEdits()

        ' Ask the user for the new customer name.
        Dim dlg As New frmNewCustomer()
        If dlg.ShowDialog(Me) = DialogResult.OK Then
            ' Get the customer name and ID.
            Dim customer_name As String = dlg.txtCompanyName.Text
            Dim customer_id As Integer = MaxCustomerId() + 1

            ' Create a new record.
            Dim data_row As DataRow = g_dtCustomers.NewRow()
            data_row.Item("CustomerId") = customer_id
            data_row.Item("CustomerName") = customer_name
            data_row.Item("CombinedName") = customer_name & " (" & customer_id & ")"
            g_dtCustomers.Rows.Add(data_row)

            ' Select the new record.
            g_cmCustomers.Position = g_cmCustomers.Count - 1

            ' Mark the data as modified.
            CheckModified()

            ' Display the new customer.
            DisplayCustomerForm()
        End If
    End Sub

    ' Delete the current customer.
    Private Sub btnCustomerDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCustomerDelete.Click
        ' Do nothing if there are no records to delete.
        If g_cmCustomers.Count < 1 Then Exit Sub

        ' Get the DataRowView.
        Dim data_row_view As DataRowView
        data_row_view = g_cmCustomers.Current()

        ' See if this this customer is currently displayed.
        Dim frm As frmCustomer = FindCustomerForm(data_row_view.Item("CustomerId"))
        If Not (frm Is Nothing) Then
            ' Close this form.
            frm.Close()
        End If

        ' Delete the record.
        data_row_view.Delete()

        ' Mark the data as modified.
        CheckModified()
    End Sub
End Class
