USE Master;
DROP DATABASE Contacts;

# Create the database.
# Comment this statement out if the database already exists
# or if you are using an Access database.
CREATE DATABASE Contacts
ON
  (NAME = ts_data,
   FILENAME = 'C:\Temp\ContactsDB.mdf',
   SIZE = 2MB,
   MAXSIZE = 10MB,
   FILEGROWTH = 2MB
)
LOG ON
  (NAME = ts_log,
   FILENAME = 'C:\Temp\ContactsDB.ldf',
   SIZE = 1MB,
   MAXSIZE = 5MB,
   FILEGROWTH = 1MB
);

# Use the new database.
# Comment this statement out if you are using an Access database.
USE Contacts;

# Contacts.
CREATE TABLE Contacts (
    FirstName           VARCHAR(20)   NOT NULL,
    LastName            VARCHAR(20)   NOT NULL,
    Street              VARCHAR(40),
    City                VARCHAR(40),
    State               CHAR(2),
    Zip                 VARCHAR(10),
    Email               VARCHAR(80),
    Notes               VARCHAR(200),
    HomePhone           VARCHAR(12),
    HomePhoneExtension  VARCHAR(4),
    HomeFax             VARCHAR(12),
    HomeFaxExtension    VARCHAR(4),
    WorkPhone           VARCHAR(12),
    WorkPhoneExtension  VARCHAR(4),
    WorkFax             VARCHAR(12),
    WorkFaxExtension    VARCHAR(4),
    SnapshotFile        VARCHAR(80),
    PRIMARY KEY (LastName, FirstName)
);
