# Create the accounts database tables.

# Create the database.
# Comment this statement out if the database already exists
# or if you are using an Access database.
CREATE DATABASE Customers
ON
  (NAME = ts_data,
   FILENAME = 'C:\Temp\Customers.mdf',
   SIZE = 2MB,
   MAXSIZE = 10MB,
   FILEGROWTH = 2MB
)
LOG ON
  (NAME = ts_log,
   FILENAME = 'C:\Temp\Customers.ldf',
   SIZE = 1MB,
   MAXSIZE = 5MB,
   FILEGROWTH = 1MB
);

# Use the new database.
# Comment this statement out if you are using an Access database.
USE Customers;

# Customers.
CREATE TABLE Customers (
    CustomerId        INT           IDENTITY(1,1) PRIMARY KEY,
    CompanyName       VARCHAR(60)   NOT NULL,
    FEIN              CHAR(9)       NOT NULL,
    AccountStatus     VARCHAR(12)   NOT NULL,
    AccountOpenedDate DATETIME      NOT NULL,
    LastBillDate      DATETIME,
    ContactFirstName  VARCHAR(20),
    ContactLastName   VARCHAR(20),
    ContactPhone      VARCHAR(12),
    ContactStreet     VARCHAR(40),
    ContactCity       VARCHAR(40),
    ContactState      CHAR(2),
    ContactZip        VARCHAR(10)
);

# Credits. A positive amount indicates a credit.
CREATE TABLE Credits (
    CustomerId        INT           NOT NULL,
    Amount            MONEY         NOT NULL,
    ReceivedDate      DATETIME      NOT NULL,
    ProcessedDate     DATETIME
);

