# Drop the existing tables.
DROP TABLE Pupils;
DROP TABLE TestScores;

# Create the new tables.
CREATE TABLE Pupils (
    FirstName   VARCHAR(20) NOT NULL,
    LastName    VARCHAR(20) NOT NULL,
    Period      INTEGER     NOT NULL,
    StudentId   INTEGER     NOT NULL	# Link to TestScores.StudentId
);

CREATE TABLE TestScores (
    TestNumber  INTEGER     NOT NULL,
    StudentId   INTEGER     NOT NULL,	# Link to Pupils.StudentId
    Score       INTEGER     NOT NULL
);

# Insert test data.
INSERT INTO Pupils VALUES ('Amy'         , 'Anderson-Archer', 3, 2001);
INSERT INTO Pupils VALUES ('Robert (Bob)', 'Baker'          , 3, 2002);

INSERT INTO TestScores VALUES (1, 2001, 91);
INSERT INTO TestScores VALUES (2, 2001, 92);
INSERT INTO TestScores VALUES (3, 2001, 93);

INSERT INTO TestScores VALUES (1, 2002, 99);
INSERT INTO TestScores VALUES (2, 2002, 98);

# Select all Pupils records.
SELECT * FROM Pupils
ORDER BY FirstName, LastName;

# Select all TestScores records.
SELECT * FROM TestScores
ORDER BY TestNumber;

# Select all students' scores.
SELECT * FROM Pupils, TestScores
WHERE Pupils.StudentId = TestScores.StudentId
ORDER BY FirstName, LastName;

# Select all students' scores with some formatting.
SELECT FirstName, LastName, Period,
  Pupils.StudentId AS ID,			# Display StudentId with the column name ID.
  TestNumber As [Test #],			# Display TestNumber as Test #.
  Score AS [%],					# The score is really a percentage.
  Score/100 AS Score				# Display the score as a decimal value.
FROM Pupils, TestScores
WHERE Pupils.StudentId = TestScores.StudentId
ORDER BY FirstName, LastName;
# End.