# Create the test scores database tables.

# Create the database.
# Comment this statement out if the database already exists
# or if you are using an Access database.
CREATE DATABASE TestScores
ON
  (NAME = ts_data,
   FILENAME = 'C:\Temp\TestScores.mdf',
   SIZE = 2MB,
   MAXSIZE = 10MB,
   FILEGROWTH = 2MB
)
LOG ON
  (NAME = ts_log,
   FILENAME = 'C:\Temp\TestScores.ldf',
   SIZE = 1MB,
   MAXSIZE = 5MB,
   FILEGROWTH = 1MB
);

# Use the new database.
# Comment this statement out if you are using an Access database.
USE TestScores;

# Students.
CREATE TABLE Students (
    StudentId       INT           IDENTITY(1,1) PRIMARY KEY,
    FirstName       VARCHAR(20)   NOT NULL,
    LastName        VARCHAR(20)   NOT NULL,
    CONSTRAINT con_Students_Names UNIQUE (FirstName, LastName)
);

# Scores.
CREATE TABLE TestScores (
    StudentId       INT           REFERENCES Students (StudentId),
    TestNumber      INT           NOT NULL,
    Score           INT           NOT NULL CHECK ((Score >= 0) AND (Score <= 100))
);
