USE Master;
DROP DATABASE TestViews;

CREATE DATABASE TestViews
ON
  (NAME = tr_data,
   FILENAME = 'C:\Temp\TestViews.mdf',
   SIZE = 2MB,
   MAXSIZE = 10MB,
   FILEGROWTH = 2MB
)
LOG ON
  (NAME = tr_log,
   FILENAME = 'C:\Temp\TestViews.ldf',
   SIZE = 1MB,
   MAXSIZE = 5MB,
   FILEGROWTH = 1MB
);
USE TestViews;

# Customers.
CREATE TABLE Customers (
    CompanyName     VARCHAR(60)   PRIMARY KEY,
    FEIN            CHAR(9)       NOT NULL,
    AccountBalance  MONEY         NOT NULL
);

# Customers.
INSERT INTO Customers VALUES ('Mike''s Software Emporium', '123456789', 100.00);
INSERT INTO Customers VALUES ('Everlasting Software Inc',  '282983755',  50.00);
INSERT INTO Customers VALUES ('Perplexment Enterprises',   '499237742',  10.00);
INSERT INTO Customers VALUES ('Abend Ender',               '765487830', -45.00);

# Create a view.
CREATE VIEW CustomerNames AS
SELECT CompanyName FROM Customers;

# Make the a_clerk user.
#sp_addlogin 'a_clerk';
sp_grantdbaccess 'a_clerk';
sp_helpuser;

# Allow a_clerk to look at CustomerNames but not Customers.
GRANT SELECT ON CustomerNames TO a_clerk;
